(* FileUtils

Ver, 1.00 2013/04/24 ꉞB
Ver, 1.01 2013/08/28 HasSymLink ǉBFileTimeToDateTime, StrToDateTime  FileTimeToLocalDateTime, StrToLocalDateTime ɉB
Ver, 1.02 2016/10/05 HasDirectory, HasSymLink gB

I/O ֘A[eBWB
FileProc p~ IOUtils gn߂񂾂ǁAꂾł͎܂ȂȂČǕB

  IOUtils+ *)

unit FileUtils;

interface

uses
  Winapi.Windows, System.SysUtils, System.StrUtils, System.Masks;

function MatchesMasks(const FileName, Masks: string): Boolean;
function MatchesCompoundMasks(const FileName, Includes, Excludes: string): Boolean;
function HasDirectory(Rec: TSearchRec): Boolean; overload;
function HasDirectory(const FileName: string): Boolean; overload;
function HasSymLink(Rec: TSearchRec): Boolean; overload;
function HasSymLink(const FileName: string): Boolean; overload;
function FileTimeToLocalDateTime(UTCFileTime: TFileTime): TDateTime;
function StrToLocalDateTime(S: string): TDateTime;

implementation

//FileName  Masks ɓK邩`FbNB
//Masks ̓p^[ ';' ŘAB
function MatchesMasks(const FileName, Masks: string): Boolean;
var
  Mask: string;
begin
  Result := False;
  for Mask in SplitString(Masks, ';') do
  begin
    Result := MatchesMask(FileName, Mask);
    if Result then Break;
  end;
end;

//FileName  Includes ɓKAExcludes ɓKȂ`FbNB
function MatchesCompoundMasks(const FileName, Includes, Excludes: string): Boolean;
begin
  Result := MatchesMasks(FileName, Includes) and not MatchesMasks(FileName, Excludes);
end;

//w背R[hfBNg`FbNB
function HasDirectory(Rec: TSearchRec): Boolean;
begin
  Result := (Rec.Attr and faDirectory) <> 0;
end;

//wt@CfBNg`FbNB
function HasDirectory(const FileName: string): Boolean;
var
  Rec: TSearchRec;
begin
  Result := FindFirst(FileName, faAnyFile, Rec) = 0;
  try
    if Result then
      Result := HasDirectory(Rec);
  finally
    FindClose(Rec);
  end;
end;

//w背R[hV{bNN`FbNB
function HasSymLink(Rec: TSearchRec): Boolean;
begin
  Result := (Rec.Attr and faSymLink) <> 0;
end;

//wt@CV{bNN`FbNB
function HasSymLink(const FileName: string): Boolean;
var
  Rec: TSearchRec;
begin
  Result := FindFirst(FileName, faAnyFile, Rec) = 0;
  try
    if Result then
      Result := HasSymLink(Rec);
  finally
    FindClose(Rec);
  end;
end;

//TFileTime ^̒l TDateTime ^ɕϊB
//UTC Ԃ烍[JԂւ̕ϊɍsB
function FileTimeToLocalDateTime(UTCFileTime: TFileTime): TDateTime;
var
  LocalFileTime: TFileTime;
  SystemTime: TSystemTime;
begin
  FileTimeToLocalFileTime(UTCFileTime, LocalFileTime);
  FileTimeToSystemTime(LocalFileTime, SystemTime);
  Result := SystemTimeToDateTime(SystemTime);
end;

// TDateTime ^ɕϊB
//UTC Ԃ烍[JԂւ̕ϊɍsB
function StrToLocalDateTime(S: string): TDateTime;
var
  UTCDateTime: TDateTime;
  SystemTime: TSystemTime;
  UTCFileTime: TFileTime;
begin
  UTCDateTime := StrToDateTime(S);
  DateTimeToSystemTime(UTCDateTime, SystemTime);
  SystemTimeToFileTime(SystemTime, UTCFileTime);
  Result := FileTimeToLocalDateTime(UTCFileTime);
end;

end.
